Description

This is a guide for setting up btcpool on FreeBSD 10.

WARNING: This fails to build on FreeBSD 10 at the moment 4/25/17

Prepare the Environment

* Make sure the system is up to date:

pkg update && pkg upgrade
portsnap fetch extract

e Create a btcpool user:
pw add user -n btcpool -s /sbin/nologin -c "BTC Pool"
¢ [nstall a few dependencies:

pkg install gcc git gmake portmaster autotools libtool autoconf automake cmake openssl boost-1
ibs gmp libconfig libzmg4 glog librdkafka libevent

e |nstall Zookeeper and ensure its running, refer to issue #3890
service zookeeper start
e |nstall Kafka and ensure its running, refer to issue #891
service kafka start
* Add the following to the make.conf file to enable ZMQ while compiling from ports:

echo 'OPTIONS_UNSET+= DOCS NLS X11 EXAMPLES' >> /etc/make.conf
echo 'OPTIONS_SET+= ZMQ' >> /etc/make.conf

e Compile bitcoin-daemon from ports:
portmaster net-p2p/bitcoin

e Compile bitcoin-daemon from ports:
portmaster net-p2p/bitcoin-daemon

Install MySQL Server

e Start by installing the mariadb100-server and mariadb100-client packages:

pkg install mariadbl00-{server,client}
e Copy a base MySQL configuration to use:

cp /usr/local/share/mysqgl/my-small.cnf /var/db/mysgl/my.cnf
e Enable and start mysql at boot:

echo 'mysgl_enable="YES"' >> /etc/rc.conf
service mysqgl-server start

® Prepare the database for use by running the secure installation:
NOTE: Choose a strong root password and answer yes to all questions.

mysql_secure_installation

Create Databases and Users

e | ogin to MySQL and create appropriate databases and users.

mysgl —-u root -p

o And run the following SQL queries to create the btcpooldb database and btcpooluser user:

CREATE DATABASE btcpooldb CHARACTER SET utf8;

CREATE USER 'btcpooluser'@'localhost' IDENTIFIED BY 'SuperSecretPassword';
GRANT ALL PRIVILEGES ON btcpooldb.* TO 'btcpooluser'@'localhost';

FLUSH PRIVILEGES;

quit

Install btcpool

e Download the latest version of btcpool from GitHub:
git clone https://github.com/btccom/btcpool.git /usr/local/btcpool
* Build btcpool using gcc:

cd /usr/local/btcpool
mkdir build && cd build

env CC=gccd48 CXX=g++48 CPP=cpp48 cmake -DCMAKE_C_COMPILER=gcc48 -DCMAKE_CXX_ COMPILER=g++48 -DC
MAKE_BUILD_TYPE=Release

env CC=gccd8 CXX=g++48 CPP=cpp48 gmake

Initialize btcpool

Create Kafka Topics
Init MySQL database tables
User list API

Init script

Resources

e https://github.com/btccom/btcpool
¢ https://github.com/btccom/btcpool/blob/master/INSTALL.md

History

#1 - 04/19/2017 09:22 PM - Daniel Curtis

- Description updated

#2 - 04/24/2017 09:38 PM - Daniel Curtis

- Description updated

#3 - 04/25/2017 08:11 PM - Daniel Curtis
- Description updated

- Status changed from New to Suspended
